Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/FolderAlreadyExistsException.java	(revision 2584)
@@ -0,0 +1,34 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.exception;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.connector.Dispatcher;
+
+/**
+ * Signals that a {@link Connector} method tried to create a folder that already exists. <br>
+ * <br> 
+ * These is an exception to signal the {@link Dispatcher} what was going wrong.
+ *
+ * @version $Id$
+ */
+public class FolderAlreadyExistsException extends Exception {
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidCurrentFolderException.java	(revision 2584)
@@ -0,0 +1,35 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.exception;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.connector.Dispatcher;
+
+/**
+ * Signals that a {@link Connector} method can't find the current folder. That's 
+ * never happened in common cases.<br>
+ * <br> 
+ * These is an exception to signal the {@link Dispatcher} what was going wrong.
+ *
+ * @version $Id$
+ */
+public class InvalidCurrentFolderException extends Exception {
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidFolderNameException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidFolderNameException.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/InvalidFolderNameException.java	(revision 2584)
@@ -0,0 +1,34 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.exception;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.connector.Dispatcher;
+
+/**
+ * Signals that a {@link Connector} method tried to create a folder and it fails. <br>
+ * <br> 
+ * These is an exception to signal the {@link Dispatcher} what was going wrong.
+ *
+ * @version $Id$
+ */
+public class InvalidFolderNameException extends Exception {
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/SecurityIssueException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/SecurityIssueException.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/SecurityIssueException.java	(revision 2584)
@@ -0,0 +1,34 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.exception;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.connector.Dispatcher;
+
+/**
+ * Thrown to indicate a security violation in a {@link Connector}.<br>
+ * <br> 
+ * These is an exception to signal the {@link Dispatcher} what was going wrong. 
+ *
+ * @version $Id$
+ */
+public class SecurityIssueException extends Exception {
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/exception/UnknownException.java	(revision 2584)
@@ -0,0 +1,33 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.exception;
+
+import net.fckeditor.connector.Dispatcher;
+
+/**
+ * Signals an undefined exception.<br>
+ * <br> 
+ * These is an exception to signal the {@link Dispatcher} what was going wrong.
+ *
+ * @version $Id$
+ */
+public class UnknownException extends Exception {
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/connector/impl/SimpleFileSystemConnector.java	(revision 2584)
@@ -0,0 +1,197 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.connector.impl;
+
+import java.io.BufferedOutputStream;
+import java.io.File;
+import java.io.FileFilter;
+import java.io.FileOutputStream;
+import java.io.InputStream;
+import java.util.ArrayList;
+import java.util.Arrays;
+import java.util.HashMap;
+import java.util.List;
+import java.util.Map;
+
+import javax.servlet.ServletContext;
+
+import net.fckeditor.connector.Connector;
+import net.fckeditor.connector.exception.FolderAlreadyExistsException;
+import net.fckeditor.connector.exception.InvalidCurrentFolderException;
+import net.fckeditor.connector.exception.InvalidFolderNameException;
+import net.fckeditor.connector.exception.SecurityIssueException;
+import net.fckeditor.connector.exception.UnknownException;
+import net.fckeditor.handlers.ConnectorHandler;
+import net.fckeditor.handlers.ResourceType;
+import net.fckeditor.requestcycle.ThreadLocalData;
+import net.fckeditor.tool.Utils;
+import net.fckeditor.tool.UtilsFile;
+
+import org.apache.commons.io.IOUtils;
+import org.apache.commons.io.filefilter.DirectoryFileFilter;
+import org.apache.commons.io.filefilter.FileFileFilter;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+/**
+ * Implementation of the {@link Connector} for the file system. All path are interpreted as sub-directories 
+ * of the {@link ConnectorHandler#getUserFilesPath()}.<br>
+ * 
+ * TODO should we move the static methods into a util-class in package net.fckeditor.connector.impl ???
+ * @version $Id$
+ */
+// FIXME the name is inappropriate, it should be ContextFileSystemConnector
+// we should provide another implementation which leads outside of the context
+// HINT: we should keep this name because it can run without any PathBuilder implementation
+public class SimpleFileSystemConnector implements Connector {
+	private static final Logger logger = LoggerFactory.getLogger(SimpleFileSystemConnector.class);
+	private static ServletContext servletContext;
+
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#init()
+	 */
+	public void init(final ServletContext servletContext) {
+		// create user's default dir
+		SimpleFileSystemConnector.servletContext = servletContext;
+		String realDefaultUserFilesPath = SimpleFileSystemConnector.servletContext.getRealPath(ConnectorHandler.getDefaultUserFilesPath());
+		File defaultUserFilesDir = new File(realDefaultUserFilesPath);
+		UtilsFile.checkDirAndCreate(defaultUserFilesDir);
+		logger.info("Initialized!");
+	}
+	
+
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#fileUpload(net.fckeditor.handlers.ResourceType, java.lang.String, java.lang.String, java.io.InputStream)
+	 */
+	public String fileUpload(final ResourceType type, final String currentFolder, final String fileName, final InputStream inputStream) 
+			throws InvalidCurrentFolderException, SecurityIssueException {
+		String baseDir = ConnectorHandler.getUserFilesPath();
+		File typeDir = getAndCreateResourceTypeDir(baseDir, type);
+		File currentDir = new File(typeDir, currentFolder);
+		if (!currentDir.exists())
+			throw new InvalidCurrentFolderException(); 
+		return upload(currentDir, fileName, inputStream);
+	}
+	
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#quickUpload(java.lang.String, java.io.InputStream)
+	 */
+	public String quickUpload(String fileName, final InputStream inputStream) throws SecurityIssueException {
+		File currentDir = new File(servletContext.getRealPath(ConnectorHandler.getUserFilesPath()));
+		return upload(currentDir, fileName, inputStream);
+	}
+
+	private String upload(final File currentDir, final String fileName, final InputStream inputStream) throws SecurityIssueException {
+		File newFile = new File(currentDir, fileName);
+		File fileToSave = UtilsFile.getUniqueFile(newFile.getAbsoluteFile());
+		try {
+			BufferedOutputStream out = new BufferedOutputStream(new FileOutputStream(fileToSave));
+			IOUtils.copyLarge(inputStream, out);
+		} catch (Exception e) {
+			throw new SecurityIssueException();
+		}
+		return fileToSave.getName();
+	}
+
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#createFolder(net.fckeditor.handlers.ResourceType, java.lang.String, java.lang.String)
+	 */
+	public void createFolder(final ResourceType type, final String currentFolder, final String newFolder) 
+			throws InvalidCurrentFolderException, SecurityIssueException, InvalidFolderNameException, FolderAlreadyExistsException {
+		String baseDir = ConnectorHandler.getUserFilesPath();
+		File typeDir = getAndCreateResourceTypeDir(baseDir, type);
+		File currentDir = new File(typeDir, currentFolder);
+		if (!currentDir.exists())
+			throw new InvalidCurrentFolderException();
+		File newDir = new File(currentDir, newFolder);
+		if (newDir.exists())
+			throw new FolderAlreadyExistsException();
+		try {
+			if (!newDir.mkdir()) 
+				throw new InvalidFolderNameException();
+		} catch (SecurityException e) {
+			throw new SecurityIssueException();
+		}
+	}
+
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#getFiles(net.fckeditor.handlers.ResourceType, java.lang.String)
+	 */
+	public List<Map<String, Object>> getFiles(ResourceType type, String currentFolder)
+			throws InvalidCurrentFolderException, SecurityIssueException, UnknownException {
+		String baseDir = ConnectorHandler.getUserFilesPath();
+		File typeDir = getAndCreateResourceTypeDir(baseDir, type);
+		File currentDir = new File(typeDir, currentFolder);
+		if (!currentDir.exists())
+			throw new InvalidCurrentFolderException();
+
+		// collect files
+		List<Map<String, Object>> files;
+		Map<String, Object> fileMap;
+		try {
+			File[] fileList = currentDir.listFiles((FileFilter) FileFileFilter.FILE);
+			files = new ArrayList<Map<String,Object>>(fileList.length);
+			for (File file : fileList) {
+				fileMap = new HashMap<String, Object>(2);
+				fileMap.put(Connector.KEY_NAME, file.getName());
+				fileMap.put(Connector.KEY_SIZE, file.length());
+				files.add(fileMap);
+			}
+			return files;
+		} catch (SecurityException e) {
+			throw new SecurityIssueException();
+		}
+	}
+
+
+	/* (non-Javadoc)
+	 * @see net.fckeditor.connector.Connector#getFolders(net.fckeditor.handlers.ResourceType, java.lang.String)
+	 */
+	public  List<String> getFolders(final ResourceType type, final String currentFolder)
+			throws InvalidCurrentFolderException, SecurityIssueException, UnknownException {
+		String baseDir = ConnectorHandler.getUserFilesPath();
+		File typeDir = getAndCreateResourceTypeDir(baseDir, type);
+		File currentDir = new File(typeDir, currentFolder);
+		if (!currentDir.exists())
+			throw new InvalidCurrentFolderException();
+		if (!currentDir.isDirectory())
+			throw new UnknownException();
+		try {
+			String[] fileList = currentDir.list(DirectoryFileFilter.DIRECTORY);
+			return Arrays.asList(fileList);
+		} catch (Exception e) {
+			throw new SecurityIssueException();
+		}
+	}
+
+	
+	private static File getAndCreateResourceTypeDir(final String baseDir, final ResourceType type) {
+		String folderStr = new String(baseDir);
+		String contextPath = ThreadLocalData.getServletRequest().getContextPath();
+		//we have to check, if there is a context path and cut it, it's obsolete for the filesystem
+		if (Utils.isNotEmpty(contextPath))
+			folderStr = folderStr.substring(contextPath.length());
+		File dir = new File(servletContext.getRealPath(folderStr), type.getPath());
+		if (!dir.exists()) 
+			dir.mkdirs();
+		return dir;
+	}
+}
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ConnectorHandler.java	(revision 2584)
@@ -21,6 +21,8 @@
 package net.fckeditor.handlers;
 
-import javax.servlet.http.HttpServletRequest;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
 
+import net.fckeditor.connector.Connector;
 import net.fckeditor.requestcycle.UserPathBuilder;
 
@@ -32,14 +34,36 @@
  */
 public class ConnectorHandler {
+	
+	private static Logger logger = LoggerFactory.getLogger(ConnectorHandler.class);
+	private static Connector connector = null;
+	
+	static {
+		
+		// 3. try to instantiate the Connector object
+		String fqcn = PropertiesLoader.getProperty("connector.implementation");
+		if (fqcn == null)
+			logger.warn("No property found for Connector implementation, any user action will be disabled!");
+		else {
+			try {
+				Class<?> clazz = Class.forName(fqcn);
+				connector = (Connector) clazz.newInstance();
+				logger.info("Connector initialized to {}", connector.getClass());
+			} catch (Exception e) {
+				logger.error("Couldn't instantiate class [".concat(fqcn).concat(
+				        "], any user action will disabled!"), e);
+			}
+		}
+	}
 
 	/**
-	 * Getter for the <code>UserFilesPath</code>.
+	 * Getter for the <code>UserFilesPath</code>.<br>
+	 * Should be use in the implementations of {@link Connector}.
 	 * 
-	 * @return {@link UserPathBuilder#getUserFilesPath(HttpServletRequest)} or
+	 * @return {@link UserPathBuilder#getUserFilesPath()} or
 	 *         the <code>DefaultUserFilePath</code> if {@link UserPathBuilder}
 	 *         isn't set.
 	 */
-	public static String getUserFilesPath(final HttpServletRequest request) {
-    	String userFilePath = RequestCycleHandler.getUserFilePath(request);
+	public static String getUserFilesPath() {
+    	String userFilePath = RequestCycleHandler.getUserFilesPath();
     	return (userFilePath != null) ? userFilePath : getDefaultUserFilesPath();
     }
@@ -63,5 +87,9 @@
 	 */
 	public static boolean isFullUrl() {
-		return Boolean.valueOf(PropertiesLoader.getProperty("connector.fullUrl"));
+		return Boolean.parseBoolean(PropertiesLoader.getProperty("connector.fullUrl"));
+	}
+	
+	public static String getBaseUrl() {
+		return PropertiesLoader.getProperty("connector.baseUrl");
 	}
 
@@ -85,3 +113,12 @@
 		return Boolean.valueOf(PropertiesLoader.getProperty("connector.secureImageUploads"));
 	}
+
+	/**
+	 * Getter for the implementation of {@link Connector}.
+	 * 
+	 * @return Implementation of {@link Connector}.
+	 */
+	public static Connector getConnector() {
+		return connector;
+	}
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ExtensionsHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ExtensionsHandler.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ExtensionsHandler.java	(revision 2584)
@@ -42,24 +42,24 @@
 public class ExtensionsHandler {
 
-	private static Map<ResourceTypeHandler, Set<String>> extensionsAllowed = new HashMap<ResourceTypeHandler, Set<String>>();
-	private static Map<ResourceTypeHandler, Set<String>> extensionsDenied = new HashMap<ResourceTypeHandler, Set<String>>();
+	private static Map<ResourceType, Set<String>> extensionsAllowed = new HashMap<ResourceType, Set<String>>();
+	private static Map<ResourceType, Set<String>> extensionsDenied = new HashMap<ResourceType, Set<String>>();
 
 	static {
 		// load defaults
-		extensionsAllowed.put(ResourceTypeHandler.FILE, Utils.getSet(PropertiesLoader
+		extensionsAllowed.put(ResourceType.FILE, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.file.extensions.allowed")));
-		extensionsDenied.put(ResourceTypeHandler.FILE, Utils.getSet(PropertiesLoader
+		extensionsDenied.put(ResourceType.FILE, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.file.extensions.denied")));
-		extensionsAllowed.put(ResourceTypeHandler.MEDIA, Utils.getSet(PropertiesLoader
+		extensionsAllowed.put(ResourceType.MEDIA, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.media.extensions.allowed")));
-		extensionsDenied.put(ResourceTypeHandler.MEDIA, Utils.getSet(PropertiesLoader
+		extensionsDenied.put(ResourceType.MEDIA, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.media.extensions.denied")));
-		extensionsAllowed.put(ResourceTypeHandler.IMAGE, Utils.getSet(PropertiesLoader
+		extensionsAllowed.put(ResourceType.IMAGE, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.image.extensions.allowed")));
-		extensionsDenied.put(ResourceTypeHandler.IMAGE, Utils.getSet(PropertiesLoader
+		extensionsDenied.put(ResourceType.IMAGE, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.image.extensions.denied")));
-		extensionsAllowed.put(ResourceTypeHandler.FLASH, Utils.getSet(PropertiesLoader
+		extensionsAllowed.put(ResourceType.FLASH, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.flash.extensions.allowed")));
-		extensionsDenied.put(ResourceTypeHandler.FLASH, Utils.getSet(PropertiesLoader
+		extensionsDenied.put(ResourceType.FLASH, Utils.getSet(PropertiesLoader
 		    .getProperty("connector.resourceType.flash.extensions.denied")));
 	}
@@ -72,5 +72,5 @@
 	 * @return Set of allowed extensions or an empty set.
 	 */
-	public static Set<String> getExtensionsAllowed(final ResourceTypeHandler type) {
+	public static Set<String> getExtensionsAllowed(final ResourceType type) {
 		return extensionsAllowed.get(type);
 	}
@@ -87,5 +87,5 @@
 	 *            Required format: <code>ext1&#124;ext2&#124;ext3</code>
 	 */
-	public static void setExtensionsAllowed(final ResourceTypeHandler type, final String extensionsList) {
+	public static void setExtensionsAllowed(final ResourceType type, final String extensionsList) {
 		if (extensionsList != null) {
 			extensionsAllowed.put(type, Utils.getSet(extensionsList));
@@ -101,5 +101,5 @@
 	 * @return Set of denied extensions or an empty set.
 	 */
-	public static Set<String> getExtensionsDenied(final ResourceTypeHandler type) {
+	public static Set<String> getExtensionsDenied(final ResourceType type) {
 		return extensionsDenied.get(type);
 	}
@@ -116,5 +116,5 @@
 	 *            Required format: <code>ext1&#124;ext2&#124;ext3</code>
 	 */
-	public static void setExtensionsDenied(final ResourceTypeHandler type, final String extensionsList) {
+	public static void setExtensionsDenied(final ResourceType type, final String extensionsList) {
 		if (extensionsList != null) {
 			extensionsDenied.put(type, Utils.getSet(extensionsList));
@@ -134,5 +134,5 @@
 	 *         is always returned if 'type' or 'extensions' is <code>null</code>.
 	 */
-	public static boolean isAllowed(final ResourceTypeHandler type, final String extension) {
+	public static boolean isAllowed(final ResourceType type, final String extension) {
 		if (type == null || extension == null)
 			return false;
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2578)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/RequestCycleHandler.java	(revision 2584)
@@ -21,5 +21,4 @@
 package net.fckeditor.handlers;
 
-import javax.servlet.http.HttpServletRequest;
 
 import net.fckeditor.requestcycle.UserAction;
@@ -42,5 +41,5 @@
 	static {
 		// If there are more objects to instantiate in future, we could solve the following by reflection!
-		
+				
 		// 1. try to instantiate the UserAction object
 		String fqcn = PropertiesLoader.getProperty("connector.userActionImpl");
@@ -77,24 +76,33 @@
 	/**
 	 * Just a wrapper to
-	 * {@link UserAction#isEnabledForFileBrowsing(HttpServletRequest)}.
+	 * {@link UserAction#isEnabledForFileBrowsing()}.
 	 * 
-	 * @param request
-	 * @return {@link UserAction#isEnabledForFileBrowsing(HttpServletRequest)}
-	 *         or false if <code>userAction</code> isn't set.
+	 * @return {@link UserAction#isEnabledForFileBrowsing()}
+	 *         or false if {@link UserAction} isn't set.
 	 */
-	public static boolean isEnabledForFileBrowsing(final HttpServletRequest request) {
-		return (userAction != null && userAction.isEnabledForFileBrowsing(request));
+	public static boolean isEnabledForFileBrowsing() {
+		return (userAction != null && userAction.isEnabledForFileBrowsing());
 	}
 
 	/**
 	 * Just a wrapper to
-	 * {@link UserAction#isEnabledForFileUpload(HttpServletRequest)}.
+	 * {@link UserAction#isEnabledForFileUpload()}.
 	 * 
-	 * @param request
-	 * @return {@link UserAction#isEnabledForFileUpload(HttpServletRequest)} or
-	 *         false if <code>userAction</code> isn't set.
+	 * @return {@link UserAction#isEnabledForFileUpload()} or
+	 *         false if {@link UserAction} isn't set.
 	 */
-	public static boolean isEnabledForFileUpload(final HttpServletRequest request) {
-		return (userAction != null && userAction.isEnabledForFileUpload(request));
+	public static boolean isEnabledForFileUpload() {
+		return (userAction != null && userAction.isEnabledForFileUpload());
+	}
+
+	/**
+	 * Just a wrapper to
+	 * {@link UserAction#isEnabledForFolderCreation()}.
+	 * 
+	 * @return {@link UserAction#isEnabledForFolderCreation()} or
+	 *         false if {@link UserAction} isn't set.
+	 */
+	public static boolean isEnabledForFolderCreation() {
+		return (userAction != null && userAction.isEnabledForFolderCreation());
 	}
 
@@ -104,14 +112,10 @@
 	 * 
 	 * @param request
-	 * @return {@link UserPathBuilder#getUserFilesPath(HttpServletRequest)} or
+	 * @return {@link UserPathBuilder#getUserFilesPath()} or
 	 *         <code>null</code> if <code>userPathBuilder</code> is
 	 *         <code>null</code>.
 	 */
-	public static String getUserFilePath(final HttpServletRequest request) {
-		return (userPathBuilder != null) ? userPathBuilder.getUserFilesPath(request) : null;
-	}
-	
-	public static String getLocalUserFilePath() {
-		return (userPathBuilder != null) ? userPathBuilder.getLocalUserFilesPath() : null;
+	public static String getUserFilesPath() {
+		return (userPathBuilder != null) ? userPathBuilder.getUserFilesPath() : null;
 	}
 }
Index: FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ResourceType.java
===================================================================
--- FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ResourceType.java	(revision 2584)
+++ FCKeditor.Java/trunk/java-core/src/main/java/net/fckeditor/handlers/ResourceType.java	(revision 2584)
@@ -0,0 +1,150 @@
+/*
+ * FCKeditor - The text editor for Internet - http://www.fckeditor.net
+ * Copyright (C) 2003-2008 Frederico Caldeira Knabben
+ * 
+ * == BEGIN LICENSE ==
+ * 
+ * Licensed under the terms of any of the following licenses at your
+ * choice:
+ * 
+ *  - GNU General Public License Version 2 or later (the "GPL")
+ *    http://www.gnu.org/licenses/gpl.html
+ * 
+ *  - GNU Lesser General Public License Version 2.1 or later (the "LGPL")
+ *    http://www.gnu.org/licenses/lgpl.html
+ * 
+ *  - Mozilla Public License Version 1.1 or later (the "MPL")
+ *    http://www.mozilla.org/MPL/MPL-1.1.html
+ * 
+ * == END LICENSE ==
+ */
+package net.fckeditor.handlers;
+
+import java.util.HashMap;
+import java.util.Map;
+
+import net.fckeditor.tool.Utils;
+
+/**
+ * Common resource type holder without any implementation (connector) specific stuff.
+ *
+ * @version $Id$
+ */
+public class ResourceType {
+	private String name;
+	private String path;
+	private static Map<String, ResourceType> types = new HashMap<String, ResourceType>(4);
+		
+	public static final ResourceType FILE = new ResourceType("file", PropertiesLoader.getProperty("connector.resourceType.file.path"));
+	public static final ResourceType FLASH = new ResourceType("flash", PropertiesLoader.getProperty("connector.resourceType.flash.path"));
+	public static final ResourceType IMAGE = new ResourceType("image", PropertiesLoader.getProperty("connector.resourceType.image.path"));
+	public static final ResourceType MEDIA = new ResourceType("media", PropertiesLoader.getProperty("connector.resourceType.media.path"));
+	
+	static {
+		types.put(FILE.getName(), FILE);
+		types.put(FLASH.getName(), FLASH);
+		types.put(IMAGE.getName(), IMAGE);
+		types.put(MEDIA.getName(), MEDIA);
+	}
+	
+	private ResourceType(final String name, final String path) {
+		this.name = name;
+		this.path = path;
+	}
+	
+	public String getName() {
+		return name;
+	}
+	
+	public String getPath() {
+		return path;
+	}
+	
+	/**
+	 * Getter for a {@link ResourceType} for a specified string. <br>
+	 * The comparison isn't case sensitive!
+	 * 
+	 * @param name A resource type to retrieve.
+	 * @return A {@link ResourceType} object holding the value
+	 *         represented by the string argument.
+	 * @throws IllegalArgumentException
+	 *            If 'name' is <code>null</code>, empty, or does not exist.
+	 */
+	public static ResourceType valueOf(final String name) {
+		if (Utils.isEmpty(name))
+			throw new IllegalArgumentException();
+
+		ResourceType rt = types.get(name.toLowerCase());
+		if (rt == null)
+			throw new IllegalArgumentException();
+		return rt;
+	}
+	
+	/**
+	 * Checks if a specified string represents a valid resource type.<br>
+	 * The comparison isn't case sensitive!
+	 * 
+	 * @param name
+	 *            A resource type string to check.
+	 * @return <code>true</code> if the string representation is valid else
+	 *         <code>false</code>.
+	 */
+	public static boolean isValid(final String name) {
+		return (Utils.isEmpty(name)) ? false : types.containsKey(name.toLowerCase());
+	}
+
+	/**
+	 * A wrapper for {@link #valueOf(String)}. It returns <code>null</code>
+	 * instead of throwing an exception.<br>
+	 * The comparison isn't case sensitive!
+	 * 
+	 * @param name
+	 *            A resource type string to check.
+	 * @return A {@link ResourceType} object holding the value
+	 *         represented by the string argument, or <code>null</code>.
+	 */
+	public static ResourceType getResourceType(final String name) {
+		try {
+			return ResourceType.valueOf(name.toLowerCase());
+		} catch (Exception e) {
+			return null;
+		}
+	}
+	
+	/**
+	 * Tries to determine ResourceType from string and return {@link #FILE} if
+	 * provided string is invalid.<br><br>
+	 * The comparison isn't case sensitive!
+	 * 
+	 * @param name
+	 * @return resource type
+	 */
+	public static ResourceType getDefaultResourceType(final String name) {
+		if (Utils.isEmpty(name))
+			return null;
+		ResourceType rt = getResourceType(name);
+		return rt == null ? FILE : rt;
+	}
+	
+	/* (non-Javadoc)
+	 * @see java.lang.Object#equals(java.lang.Object)
+	 */
+	@Override
+	public boolean equals(Object obj) {
+		if (obj == null || !(obj instanceof ResourceType))
+			return false;
+		else {
+			ResourceType rt = (ResourceType)obj;
+			return name.equals(rt.getName());
+		}
+	}
+	
+	/*
+	 * (non-Javadoc)
+	 * @see java.lang.Object#hashCode()
+	 */
+	@Override
+	public int hashCode() {
+		return name.hashCode();
+	}
+}
